(function() {
  var OptionParser, argv, coffee, fs, mimeograph, puts, switches, usage;
  fs = require('fs');
  coffee = require('coffee-script');
  puts = require('../src/utils').puts;
  mimeograph = require('../src/mimeograph');
  OptionParser = require('coffee-script/lib/optparse').OptionParser;
  require.extensions['.coffee'] = function(module, filename) {
    var content;
    content = coffee.compile(fs.readFileSync(filename, 'utf8'));
    return module._compile(content, filename);
  };
  usage = 'Usage:\n  mimeograph [OPTIONS] [ID] filename';
  switches = [['-h', '--help', 'Displays options'], ['-v', '--version', "Shows certain's version."], ['-w', '--workers [NUMBER]', 'Number of workers to create. (Default: 5)'], ['-s', '--start', 'Starts a Mimeograph daemon.'], ['-p', '--process', 'Kicks of the processing of a new file.'], ['', '--port [NUMBER]', "Redis port. (Default: Redis' default)"], ['', '--host [STRING]', "Redis host. (Default: Redis' default)"]];
  argv = process.argv.slice(2);
  this.run = function() {
    var args, options, parser;
    parser = new OptionParser(switches, usage);
    options = parser.parse(argv);
    args = options.arguments;
    delete options.arguments;
    if (args.length === 0 && argv.length === 0) {
      puts(parser.help());
      puts("v" + mimeograph.version);
      process.exit();
    }
    if (options.help) {
      puts(parser.help());
      process.exit();
    }
    if (options.version) {
      puts("v" + mimeograph.version);
      process.exit();
    }
    if (options.start) {
      mimeograph.start(options.host, options.port, options.workers);
    }
    if (options.process) {
      return mimeograph.process(args);
    }
  };
}).call(this);
