(function() {
  var inspect, log, puts, stringify, _, _ref;
  require('colors');
  _ = require('underscore');
  puts = console.log;
  _ref = require('util'), log = _ref.log, inspect = _ref.inspect;
  exports.log = function(msg) {
    return log(msg.green);
  };
  exports.log.warn = function(msg) {
    return log(msg.yellow);
  };
  exports.log.err = function(msg) {
    return log(msg.red);
  };
  exports.puts = function(obj) {
    return puts(stringify(obj));
  };
  exports.puts.green = function(obj) {
    return puts(stringify(obj).green);
  };
  exports.puts.red = function(obj) {
    return puts(stringify(obj).red);
  };
  exports.puts.stderr = function(obj) {
    return process.stderr.write("" + (stringify(obj)) + "\n");
  };
  exports.puts.grey = function(obj) {
    return puts(stringify(obj).grey);
  };
  stringify = function(obj) {
    if (_.isString(obj)) {
      return obj;
    } else {
      return inspect(obj);
    }
  };
  exports._ = _;
  exports._.isObject = function(val) {
    return '[object Object]' === toString.apply(val);
  };
  exports._.isEmptyObject = function(val) {
    return _.isObject(val) && _.isEmpty(val);
  };
  exports._.now = function() {
    return new Date().toISOString();
  };
  exports._.basename = function(file) {
    return file.substr(0, file.indexOf('.'));
  };
  exports._.pageNumber = function(file) {
    return file.substring(file.lastIndexOf('-') + 1, file.indexOf('.'));
  };
  exports._.lpad = function(val, length, char) {
    if (length == null) {
      length = 10;
    }
    if (char == null) {
      char = '0';
    }
    val = val.toString().split("");
    while (val.length < length) {
      val.unshift(char);
    }
    return val.join('');
  };
  process.on('uncaughtException', function(err) {
    exports.log.err("" + err.stack);
    return process.exit(-1);
  });
}).call(this);
